<template lang="pug">
  section.container.user-profile(
    v-loading="profileLoad")

    h1.h2.main-heading(
      v-if="$store.state.userAuth") Личный кабинет

    .row
      el-form.col-xl-6.col-md-12(
        v-if="stateForm && user"
        ref='profileForm'
        :model='stateForm'
        :rules="rules")

        el-form-item(
          v-for="item in profileForm"
          v-if="item.name !== 'password' || item.name === 'password' && viewNewPassword"
          :key="item.id"
          :prop="item.name"
          style="margin-bottom:35px")

          app-input(
            :placeholder="item.placeholder"
            :model="item.model"
            :name="item.name"
            :id="item.id"
            :submitFunc="updateUser"
            :type="item.type"
            :label="item.label"
            :required="item.required"
            :formRef="'profileForm'"
            @input-value="modelValue")

    el-button(
      v-if="!viewNewPassword && stateForm && user"
      type="text"
      :style="actionButtonStyle"
      @click="viewNewPassword = !viewNewPassword") Изменить пароль

    .activity__block.col-xl-6.col-md-12

      .button-wrapper
        button.nuxt-button-link(
          v-if="stateForm && user"
          @click="updateUser('profileForm')")
          |Сохранить изменения

</template>

<script>
import { mapMutations } from 'vuex';

import InputItem from '../../components/InputItem';

export default {
  name: 'UserProfile',
  components: {
    'app-input': InputItem
  },
  head() {
    return {
      title: 'Личный кабинет | АО «Шувалово»'
    };
  },
  data() {
    return {
      profileLoad: false,
      viewNewPassword: false,
      profileForm: [
        {
          id: 1,
          placeholder: 'Укажите вашу фамилию',
          model: '',
          label: 'Фамилия',
          name: 'lastName'
        },
        {
          id: 2,
          placeholder: 'Укажите ваше имя',
          model: '',
          label: 'Имя',
          name: 'firstName'
        },
        {
          id: 3,
          placeholder: 'Укажите ваше отчество',
          model: '',
          label: 'Отчество',
          name: 'middleName'
        },
        {
          id: 4,
          placeholder: 'Укажите ваш email',
          model: '',
          label: 'Email',
          name: 'email',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите email',
              trigger: 'change'
            },
            {
              type: 'email',
              message: 'Пожалуйста, укажите верный email',
              trigger: 'change'
            }
          ]
        },
        {
          id: 5,
          placeholder: '+7 (999) 999 99 99',
          model: '',
          label: 'Телефон',
          type: 'phone',
          name: 'phone'
        },
        {
          id: 6,
          placeholder: 'Введите пароль',
          model: '',
          label: 'Пароль',
          name: 'oldPassword',
          type: 'password',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите пароль',
              trigger: 'change'
            },
            {
              min: 6,
              message: 'Пароль не менее 6-ти символов',
              trigger: 'change'
            }
          ]
        },
        {
          id: 7,
          placeholder: 'Введите пароль',
          model: '',
          label: 'Новый пароль',
          name: 'password',
          type: 'password'
        }
      ],
      actionButtonStyle: {
        'margin-bottom': '10px'
      },
      password: '',
      currentUser: null
    };
  },
  computed: {
    user() {
      let user = this.$store.state.user;
      if (user) {
        this.profileForm.forEach(item => {
          item.model = user[item.name];
        });
      }
      return user;
    },
    stateForm() {
      let state = {};
      this.profileForm.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.profileForm.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  mounted() {
    this.SET_LOADING(false);
  },
  methods: {
    ...mapMutations(['SET_LOADING']),
    modelValue(valueArr) {
      let index = this.profileForm.findIndex(item => item.id === valueArr[0]);
      this.profileForm[index].model = valueArr[1];
    },
    updateUser(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.profileLoad = true;
          let pathState = {
            firstName: this.stateForm.firstName,
            lastName: this.stateForm.lastName,
            middleName: this.stateForm.middleName,
            email: this.stateForm.email,
            phone: this.stateForm.phone,
            oldPassword: this.stateForm.oldPassword
          };
          if (this.stateForm.password) {
            pathState.password = this.stateForm.password;
          }
          this.$axios
            .patch(`/api/v1/users/${this.user.id}`, pathState)
            .then(
              data => {
                this.$store.commit('user', data.data);
                this.profileLoad = false;
                this.viewNewPassword = false;
                this.$message.success('Данные профиля успешно изменены!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error(
                  'Ошибка! Проверьте правильность введенных данных.'
                );
                this.profileLoad = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.profileLoad = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
